
def zip_longest(*args, fillvalue=0):
    from itertools import zip_longest
    from collections import deque

    def _fill_value(fillvalue):
        if isinstance(fillvalue, (list, tuple)):
            return [fillvalue] * len(args)
        return fillvalue

    fillvalues = _fill_value(fillvalue)
    iterators = [deque(iter(arg)) for arg in args]
    while iterators:
        values = []
        for i, iterator in enumerate(iterators):
            try:
                values.append(next(iterator))
            except StopIteration:
                iterators[i] = iter(fillvalues[i])
                values.append(next(iterators[i]))
        yield tuple(values)



